	/* ################################################################################################boo#######################
	
	IRPowerUp script by Maru
	For Corona Renderer 4 and newer
	--25.06.2019--
	
	If you find this script useful, you may use it free of charge for personal and commercial work. 
	You may freely copy, share, and modify this script, and use it for educational purposes, but please consider the following:
	- It would be great if you could mention the author of this script (Maru) and other script authors who are listed below in the modified version of the script, and on the website/post where you will share it. 
	- Please do not pretend that you are the original author of this script. 
	
	Credits:
	To create this script I used parts of other scripts, but they were mostly basic commands, which can be easily found in the Maxscript documentation and other online resources. 
	- Corona Renderer Tweaker by Stan_Booth - https://corona-renderer.com/forum/index.php?topic=6827.0
	- Corona Converter by Martin Geupel - http://www.racoon-artworks.de
	- Corona Listener by Phasma - https://corona-renderer.com/forum/index.php?topic=16571.0
	
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
	WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
	COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
	OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
	
	##########################################################################################################################  */

rollout ir "IR" width:500 height:320
(
	

	label 'lbl1' "ATTN: This script will overwrite your render settings including system settings!" pos:[8,8] width:504 height:15 align:#left
 
	label 'lbl2' "Backup your render settings before using it!" pos:[43,22] width:224 height:15 align:#left
	
	
	button 'savesettings' "Backup current render settings" pos:[8,42] width:160 height:20 align:#left
		on savesettings pressed do
		( renderPresets.SaveAll 0 (GetDir #renderPresets + "/powerup-original.rps")
		)
	
	button 'loadsettings' "Load backup render settings" pos:[185,42] width:160 height:20 align:#left
		on loadsettings pressed do
		( renderPresets.LoadAll 0 (GetDir #renderPresets + "/powerup-original.rps")
		)
		

		
	checkbox 'useEnv' "Env map" pos:[368,71] width:60 height:16 checked:true align:#left
		on useEnv changed state do
		try ( ( useEnvironmentMap = state) ) catch()

	colorPicker 'envColor' "" pos:[432,71] width:44 height:20 color:(color 0 0 0) align:#left
		on envColor changed val do
		try ( (backgroundColor = envColor.color) ) catch()
	
	spinner 'ev' "EV:" pos:[216,71] width:47 height:16 range:[-20,20,0] type:#float scale:0.1 align:#left
		on ev changed val do
		try ( (renderers.current.colorMap_simpleExposure = ev.value) ) catch()

	spinner 'irPassLim' "Pass limit: " pos:[8,95] width:71 height:16 range:[0,999,0] type:#integer scale:0.1 align:#left
		on irPassLim changed val do
		try ( (renderers.current.interactive_passLimit = irPassLim.value ) ) catch()

	checkbox 'denoise' "Denoise" pos:[124,95] width:58 height:16 checked:false align:#left
		on denoise changed state do
		try ( ( renderers.current.denoise_duringRender = state) ) catch()	

	checkbox 'matOverride' "Material override" pos:[216,95] width:128 height:16 checked:false align:#left
		on matOverride changed state do
		try ( ( renderers.current.mtlOverride_enabled = state) ) catch()	

	checkbox 'hiddenLights' "Render hidden lights" pos:[368,95] width:120 height:16 checked:true align:#left
		on hiddenLights changed state do
		try ( ( renderers.current.lights_renderHidden = state) ) catch()
			

	button 'evplus' "+1" pos:[320,71] width:24 height:16 align:#left
		on evplus pressed do
		( ev.value=ev.value+1		
		try ( (renderers.current.colorMap_simpleExposure = ev.value) ) catch()
		)

	button 'evminus' "-1" pos:[288,71] width:24 height:16 align:#left
		on evminus pressed do
		( ev.value=ev.value-1
		try ( (renderers.current.colorMap_simpleExposure = ev.value) ) catch()
		)
	
	radiobuttons 'rad_buttons' "" pos:[8,71] width:202 height:16 labels:#("Turbo!", "Deafult", "Quality") default:2 columns:3 offsets:#([0,0], [0,0], [0,0]) align:#left 
		on rad_buttons changed type do
			(
 				case type of
 				(
 					1: (renderers.current.shading_giToAaRatio = 4; 
						renderers.current.lights_samplesMult = 1; 
						renderers.current.shading_maxSampleIntensity = 10;
						renderers.current.shading_maxRayDepth = 5;
						renderers.current.interactive_forcePt = true;
						renderers.current.interactive_numThreads = 0;
						renderers.current.progressive_interlacingLevel = 4;
						renderers.current.colorMap_enabled = false;
						renderers.current.colorMap_lut_enable = false;
						renderers.current.bloomGlare_enabled = false;
						renderers.current.sharpening_blurring_enable = false;
						
						)
 					2: (renderers.current.shading_giToAaRatio = 16;
						renderers.current.lights_samplesMult = 2;
						renderers.current.shading_maxSampleIntensity = 20;
						renderers.current.shading_maxRayDepth = 25;
						renderers.current.interactive_forcePt = false;
						renderers.current.interactive_numThreads = -1;
						renderers.current.progressive_interlacingLevel = 3;
						)
 					3: (renderers.current.shading_giToAaRatio = 64;
						renderers.current.lights_samplesMult = 2;
						renderers.current.shading_maxSampleIntensity = 20;
						renderers.current.shading_maxRayDepth = 25;
						renderers.current.interactive_forcePt = false;
						renderers.current.interactive_numThreads = -1;
						renderers.current.progressive_interlacingLevel = 3;
						)
 				)
 			)
)


CPowerup = newRolloutFloater "IR PowerUp!" 500 150
addRollout IR CPowerup









